## boost1.67 1.67.0

=== libs/beast/CMakeLists.txt ===
#
# Copyright (c) 2016-2017 Vinnie Falco (vinnie dot falco at gmail dot com)
#
# Distributed under the Boost Software License, Version 1.0. (See accompanying
# file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# Official repository: https://github.com/boostorg/beast
#

cmake_minimum_required (VERSION 3.5.1)

project (Beast VERSION 167)

set_property (GLOBAL PROPERTY USE_FOLDERS ON)
option (Beast_BUILD_EXAMPLES "Build examples" ON)
option (Beast_BUILD_TESTS "Build tests" ON)

if (MSVC)
    set (CMAKE_VERBOSE_MAKEFILE FALSE)

    add_definitions (-D_WIN32_WINNT=0x0601)
    add_definitions (-D_SCL_SECURE_NO_WARNINGS=1)
    add_definitions (-D_CRT_SECURE_NO_WARNINGS=1)

    add_compile_options(
        /bigobj       # large object file format
        /permissive-  # strict C++
        #/wd4503      # decorated name length exceeded, name was truncated
        /W4           # enable all warnings
        /MP           # Multi-processor compilation
        )

    set (Boost_USE_STATIC_LIBS ON)
    set (Boost_USE_STATIC_RUNTIME ON)

    set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
    set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /Ob2 /Oi /Ot /GL /MT")
    set (CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /Oi /Ot /MT")

    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /SAFESEH:NO")
    set (CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")

    # for RelWithDebInfo builds, disable incremental linking
    # since CMake sets it ON by default for that build type and it
    # causes warnings
    #
    string (REPLACE "/INCREMENTAL" "/INCREMENTAL:NO" replacement_flags
        ${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO})
    set (CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO ${replacement_flags})

else()
    set (THREADS_PREFER_PTHREAD_FLAG ON)
    find_package (Threads)

    set( CMAKE_CXX_FLAGS
      "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wextra -Wpedantic -Wno-unused-parameter")

    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wrange-loop-analysis")
    endif ()
endif()

# Must come before Boost includes, otherwise the
# IDE sees the wrong file due to boost/ symlinks.
include_directories (include)

#-------------------------------------------------------------------------------
#
# Boost
#

get_filename_component (BOOST_ROOT ../../ ABSOLUTE)

# VFALCO I want static but "b2 stage" builds a minimal set which excludes static
add_definitions (-DBOOST_ALL_STATIC_LINK=1)

# Some of the tests use deprecated APIs
#add_definitions (-DBOOST_ASIO_NO_DEPRECATED=1)

add_definitions (-DBOOST_ASIO_DISABLE_BOOST_ARRAY=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_BIND=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_DATE_TIME=1)
add_definitions (-DBOOST_ASIO_DISABLE_BOOST_REGEX=1)
add_definitions (-DBOOST_COROUTINES_NO_DEPRECATION_WARNING=1)

include_directories (${BOOST_ROOT})

link_directories(${BOOST_ROOT}/stage/lib)

if (MINGW)
    link_libraries(ws2_32 mswsock)
endif()

#-------------------------------------------------------------------------------
#
# OpenSSL
#

if (APPLE AND NOT DEFINED ENV{OPENSSL_ROOT_DIR})
  find_program(HOMEBREW brew)
  if (NOT HOMEBREW STREQUAL "HOMEBREW-NOTFOUND")
    execute_process(COMMAND brew --prefix openssl
      OUTPUT_VARIABLE OPENSSL_ROOT_DIR
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()
endif()

find_package(OpenSSL)

if (OPENSSL_FOUND)
    add_definitions (-DBOOST_BEAST_USE_OPENSSL=1)

else()
    add_definitions (-DBOOST_BEAST_USE_OPENSSL=0)
    message("OpenSSL not found.")
endif()

#
#-------------------------------------------------------------------------------

function (DoGroupSources curdir rootdir folder)
    file (GLOB children RELATIVE ${PROJECT_SOURCE_DIR}/${curdir} ${PROJECT_SOURCE_DIR}/${curdir}/*)
    foreach (child ${children})
        if (IS_DIRECTORY ${PROJECT_SOURCE_DIR}/${curdir}/${child})
            DoGroupSources (${curdir}/${child} ${rootdir} ${folder})
        elseif (${child} STREQUAL "CMakeLists.txt")
            source_group("" FILES ${PROJECT_SOURCE_DIR}/${curdir}/${child})
        else()
            string (REGEX REPLACE ^${rootdir} ${folder} groupname ${curdir})
            string (REPLACE "/" "\\" groupname ${groupname})
            source_group (${groupname} FILES ${PROJECT_SOURCE_DIR}/${curdir}/${child})
        endif()
    endforeach()
endfunction()

function (GroupSources curdir folder)
    DoGroupSources (${curdir} ${curdir} ${folder})
endfunction()

#-------------------------------------------------------------------------------

if ("${VARIANT}" STREQUAL "coverage")
    if (MSVC)
    else()
        set (CMAKE_BUILD_TYPE DEBUG)
        set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2 --coverage")
        set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
    endif()

elseif ("${VARIANT}" STREQUAL "ubasan")
    if (MSVC)
    else()
        set (CMAKE_BUILD_TYPE RELWITHDEBINFO)
        set (CMAKE_CXX_FLAGS
          "${CMAKE_CXX_FLAGS} -DBOOST_BEAST_NO_SLOW_TESTS=1 -msse4.2 -funsigned-char -fno-omit-frame-pointer -fsanitize=address,undefined -fno-sanitize-recover=address,undefined -fsanitize-blacklist=${PROJECT_SOURCE_DIR}/tools/blacklist.supp")
        set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address,undefined -fno-sanitize-recover=address,undefined")
    endif()

elseif ("${VARIANT}" STREQUAL "debug")
    set (CMAKE_BUILD_TYPE DEBUG)

elseif ("${VARIANT}" STREQUAL "release")
    set (CMAKE_BUILD_TYPE RELEASE)

endif()

#-------------------------------------------------------------------------------
#
# Tests and examples
#

include_directories (.)

if (OPENSSL_FOUND)
    include_directories (${OPENSSL_INCLUDE_DIR})
endif()

file (GLOB_RECURSE BOOST_BEAST_FILES
    ${PROJECT_SOURCE_DIR}/include/boost/beast/*.hpp
    ${PROJECT_SOURCE_DIR}/include/boost/beast/*.ipp
)

file (GLOB_RECURSE COMMON_FILES
    ${PROJECT_SOURCE_DIR}/example/common/*.hpp
  )

if (Beast_BUILD_EXAMPLES AND
    (NOT "${VARIANT}" STREQUAL "coverage") AND
    (NOT "${VARIANT}" STREQUAL "ubasan"))
    add_subdirectory (example)
endif()

if (Beast_BUILD_TESTS)
    add_subdirectory (test)
endif()

=== libs/hana/test/CMakeLists.txt ===
# Copyright Louis Dionne 2013-2017
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE.md or copy at http://boost.org/LICENSE_1_0.txt)

add_custom_target(tests COMMENT "Build all the unit tests.")
add_dependencies(check tests)


##############################################################################
# Take note of files that depend on Boost
##############################################################################
file(GLOB_RECURSE TESTS_REQUIRING_BOOST "ext/boost/*.cpp"
                                        "experimental/printable/*.cpp")

file(GLOB_RECURSE PUBLIC_HEADERS_REQUIRING_BOOST
    RELATIVE "${Boost.Hana_SOURCE_DIR}/include"
    "${Boost.Hana_SOURCE_DIR}/include/boost/hana/ext/boost/*.hpp"
    "${Boost.Hana_SOURCE_DIR}/include/boost/hana/ext/boost.hpp"
    "${Boost.Hana_SOURCE_DIR}/include/boost/hana/experimental/printable.hpp"
)


##############################################################################
# Caveats: Take note of public headers and tests that are not supported.
##############################################################################
if (NOT Boost_FOUND)
    list(APPEND EXCLUDED_UNIT_TESTS ${TESTS_REQUIRING_BOOST})
    list(APPEND EXCLUDED_PUBLIC_HEADERS ${PUBLIC_HEADERS_REQUIRING_BOOST})
endif()

# The experimental::type_name test is only supported on Clang >= 3.6 and
# AppleClang >= 7.0
if (NOT ((${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang" AND
          NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 3.6)
        OR (${CMAKE_CXX_COMPILER_ID} STREQUAL "AppleClang" AND
            NOT ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 7)))
    list(APPEND EXCLUDED_PUBLIC_HEADERS
        "boost/hana/experimental/type_name.hpp")
    list(APPEND EXCLUDED_UNIT_TESTS "experimental/type_name.cpp")
endif()

# On Windows, Clang-cl emulates a MSVC bug that causes EBO not to be applied
# properly. We disable the tests that check for EBO.
if (MSVC AND ${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    list(APPEND EXCLUDED_UNIT_TESTS
        "detail/ebo.cpp"
        "issues/github_202.cpp"
        "pair/empty_storage.cpp"
        "tuple/empty_member.cpp"
    )
endif()


##############################################################################
# Generate tests that include each public header.
# The headers that were excluded above due to caveats are ignored here.
##############################################################################
add_custom_target(test.headers COMMENT "Build all the header-inclusion unit tests.")
add_dependencies(tests test.headers)

file(GLOB_RECURSE PUBLIC_HEADERS
    RELATIVE "${Boost.Hana_SOURCE_DIR}/include"
    "${Boost.Hana_SOURCE_DIR}/include/*.hpp"
)
list(REMOVE_ITEM PUBLIC_HEADERS ${PUBLIC_HEADERS_REQUIRING_BOOST})

include(TestHeaders)
add_header_test(test.headers.standalone EXCLUDE_FROM_ALL
                                        HEADERS ${PUBLIC_HEADERS}
                                        EXCLUDE ${EXCLUDED_PUBLIC_HEADERS})
target_link_libraries(test.headers.standalone PRIVATE hana)
add_dependencies(test.headers test.headers.standalone)

if (Boost_FOUND)
    add_header_test(test.headers.boost EXCLUDE_FROM_ALL
                                       HEADERS ${PUBLIC_HEADERS_REQUIRING_BOOST}
                                       EXCLUDE ${EXCLUDED_PUBLIC_HEADERS})
    target_link_libraries(test.headers.boost PRIVATE hana Boost::boost)
    add_dependencies(test.headers test.headers.boost)
endif()


##############################################################################
# Check for ODR violations when linking several translation units
# (GitHub issue 75)
##############################################################################
list(APPEND EXCLUDED_UNIT_TESTS "issues/github_75/*.cpp")
boost_hana_target_name_for(github_75 "${CMAKE_CURRENT_LIST_DIR}/issues/github_75")
add_executable(${github_75} EXCLUDE_FROM_ALL "issues/github_75/tu1.cpp" "issues/github_75/tu2.cpp")
boost_hana_set_test_properties(${github_75})
add_test(${github_75} "${CMAKE_CURRENT_BINARY_DIR}/${github_75}")
add_dependencies(tests ${github_75})


##############################################################################
# Add all the remaining unit tests
##############################################################################
file(GLOB_RECURSE UNIT_TESTS "*.cpp")
file(GLOB_RECURSE EXCLUDED_UNIT_TESTS ${EXCLUDED_UNIT_TESTS})
list(REMOVE_ITEM UNIT_TESTS ${EXCLUDED_UNIT_TESTS})

foreach(_file IN LISTS UNIT_TESTS)
    boost_hana_target_name_for(_target "${_file}")
    add_executable(${_target} EXCLUDE_FROM_ALL "${_file}")
    boost_hana_set_test_properties(${_target})
    if (_file IN_LIST TESTS_REQUIRING_BOOST)
        target_link_libraries(${_target} PRIVATE Boost::boost)
    endif()
    target_include_directories(${_target} PRIVATE _include)
    add_test(${_target} "${CMAKE_CURRENT_BINARY_DIR}/${_target}")
    add_dependencies(tests ${_target})
endforeach()


##############################################################################
# Add the deployment test, which checks that we can indeed install `hana` and
# then use the provided `HanaConfig.cmake` config file to use `hana` from an
# external project.
##############################################################################
include(ExternalProject)
set(HANA_FAKE_INSTALL_DIR "${CMAKE_CURRENT_BINARY_DIR}/deploy/fakeroot")
ExternalProject_Add(test.deploy.fakeroot
  SOURCE_DIR "${PROJECT_SOURCE_DIR}"
  EXCLUDE_FROM_ALL TRUE
  BUILD_ALWAYS TRUE
  CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${HANA_FAKE_INSTALL_DIR}
             -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}
             -DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}
  TEST_COMMAND ""      # Disable test step
  UPDATE_COMMAND ""    # Disable source work-tree update
)

add_custom_target(test.deploy
  DEPENDS test.deploy.fakeroot
  COMMAND ${CMAKE_COMMAND} -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/deploy/build"
  COMMAND ${CMAKE_COMMAND} -E chdir "${CMAKE_CURRENT_BINARY_DIR}/deploy/build"
            ${CMAKE_COMMAND} "${CMAKE_CURRENT_SOURCE_DIR}/deploy"
                             -DCMAKE_CXX_COMPILER="${CMAKE_CXX_COMPILER}"
                             -DCMAKE_PREFIX_PATH="${HANA_FAKE_INSTALL_DIR}"
                             -DCMAKE_GENERATOR=${CMAKE_GENERATOR}
                             -DCMAKE_TOOLCHAIN_FILE="${CMAKE_TOOLCHAIN_FILE}"
  COMMAND ${CMAKE_COMMAND} --build "${CMAKE_CURRENT_BINARY_DIR}/deploy/build"
  USES_TERMINAL
)
add_dependencies(check test.deploy)

=== libs/test/build/CMakeLists.txt ===
# Copyright 2014, Raffi Enficiaud

# Use, modification, and distribution are subject to the
# Boost Software License, Version 1.0. (See accompanying file
# LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# See http://www.boost.org/libs/test for the library home page.

cmake_minimum_required(VERSION 2.8.11)
project(BoostTest)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set(CMAKE_MACOSX_RPATH ON)

add_definitions(-DBOOST_TEST_NO_LIB)

# build type, by default to release (with optimisations)
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

if(NOT WITHOUT_TESTS)
  # ctest sets BUILD_TESTING automatically, but does not seem to serve its purpose.
  include(CTest)
  enable_testing()
endif()


include(CheckCXXCompilerFlag)
include(CheckIncludeFileCXX)

if(NOT MSVC)
  # c++11 options
  check_cxx_compiler_flag(-std=c++11 HAS_CXX11_FLAG)
  check_cxx_compiler_flag(-std=c++0x HAS_CXX0X_FLAG)
  if(HAS_CXX11_FLAG)
    message(STATUS "Compiling with C++11 support")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  elseif(HAS_CXX0X_FLAG)
    #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
  endif()
endif()

if(MSVC)
  add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS)
  set(MSVC_Additional_flags "/fp:fast /GF /Oy /GT /Ox /Ob2 /Oi /Os")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${MSVC_Additional_flags}")
endif()





# global path
set(BOOST_TEST_ROOT_DIR ${BoostTest_SOURCE_DIR}/..)
set(BOOST_ROOT_DIR ${BOOST_TEST_ROOT_DIR}/../..)
get_filename_component(BOOST_TEST_ROOT_DIR_ABS ${BoostTest_SOURCE_DIR}/.. ABSOLUTE)
get_filename_component(BOOST_ROOT_DIR_ABS ${BOOST_ROOT_DIR} ABSOLUTE)

# global include on boost
include_directories(${BOOST_ROOT_DIR_ABS}/)

# include globs
file(GLOB_RECURSE
     BOOST_UTF_HEADERS
     ${BOOST_TEST_ROOT_DIR}/include/*.hpp
     ${BOOST_TEST_ROOT_DIR}/include/*.ipp)

# organize files
foreach(_h IN LISTS BOOST_UTF_HEADERS)
  get_filename_component(_hh ${_h} ABSOLUTE)
  file(RELATIVE_PATH _v ${BOOST_TEST_ROOT_DIR_ABS}/include/boost/test ${_hh})
  get_filename_component(_v "${_v}" DIRECTORY)
  string(REPLACE "/" "\\" _v "${_v}")
  source_group(${_v} FILES ${_h})
endforeach()

set(BOOST_UTF_SRC
    ${BOOST_TEST_ROOT_DIR}/src/compiler_log_formatter.cpp

    ${BOOST_TEST_ROOT_DIR}/src/debug.cpp
    ${BOOST_TEST_ROOT_DIR}/src/decorator.cpp
    ${BOOST_TEST_ROOT_DIR}/src/execution_monitor.cpp
    ${BOOST_TEST_ROOT_DIR}/src/framework.cpp
    ${BOOST_TEST_ROOT_DIR}/src/junit_log_formatter.cpp
    ${BOOST_TEST_ROOT_DIR}/src/plain_report_formatter.cpp
    ${BOOST_TEST_ROOT_DIR}/src/progress_monitor.cpp
    ${BOOST_TEST_ROOT_DIR}/src/results_collector.cpp
    ${BOOST_TEST_ROOT_DIR}/src/results_reporter.cpp
    ${BOOST_TEST_ROOT_DIR}/src/test_framework_init_observer.cpp
    ${BOOST_TEST_ROOT_DIR}/src/test_tools.cpp
    ${BOOST_TEST_ROOT_DIR}/src/test_tree.cpp
    ${BOOST_TEST_ROOT_DIR}/src/unit_test_log.cpp
    ${BOOST_TEST_ROOT_DIR}/src/unit_test_main.cpp
    ${BOOST_TEST_ROOT_DIR}/src/unit_test_monitor.cpp
    ${BOOST_TEST_ROOT_DIR}/src/unit_test_parameters.cpp
    ${BOOST_TEST_ROOT_DIR}/src/xml_log_formatter.cpp
    ${BOOST_TEST_ROOT_DIR}/src/xml_report_formatter.cpp
    )

add_library(boost_test_framework
            STATIC
            ${BOOST_UTF_HEADERS}
            ${BOOST_UTF_SRC})
target_compile_definitions(boost_test_framework PUBLIC "-DBOOST_TEST_DYN_LINK=0")
target_include_directories(boost_test_framework PUBLIC ${BOOST_TEST_ROOT_DIR}/include/)
set_target_properties(boost_test_framework PROPERTIES FOLDER "UTF")


####
# Documentation files (files only, no target)
file(GLOB_RECURSE
     BOOST_UTF_DOC_FILES
     ${BOOST_TEST_ROOT_DIR}/doc/*.qbk)
add_custom_target(
  quickbook
  SOURCES ${BOOST_UTF_DOC_FILES})
set_property(TARGET quickbook PROPERTY FOLDER "Documentation/")


####
# Unit tests

# documentation tests
file(GLOB_RECURSE
     BOOST_UTF_DOC_EXAMPLES
     ${BOOST_TEST_ROOT_DIR}/doc/examples/*.cpp)

foreach(_h IN LISTS BOOST_UTF_DOC_EXAMPLES)
  get_filename_component(_hh ${_h} NAME_WE)
  add_executable(doc-${_hh} ${_h} ${BOOST_TEST_ROOT_DIR}/doc/examples/${_hh}.output)
  target_include_directories(doc-${_hh} PUBLIC ${BOOST_TEST_ROOT_DIR}/include/)
  set_target_properties(doc-${_hh} PROPERTIES FOLDER "Doc examples")

  add_test(NAME doc-${_hh}-test
           COMMAND doc-${_hh})
  get_filename_component(_ext ${_h} EXT)
  string(FIND ${_ext} "fail" _index_fail)
  if(${_index_fail} GREATER -1)
    message(STATUS "test ${_hh}.${_ext} = ${_index_fail}")
    set_tests_properties(doc-${_hh}-test PROPERTIES WILL_FAIL TRUE)
  endif()
endforeach()


# unit tests folder
set(BOOST_TEST_UNITTESTS_FOLDER ${BOOST_TEST_ROOT_DIR}/test)

# datasets
file(GLOB
     BOOST_TEST_UNITTESTS_DATASET
     ${BOOST_TEST_UNITTESTS_FOLDER}/test-organization-ts/datasets-test/*.cpp
     ${BOOST_TEST_UNITTESTS_FOLDER}/test-organization-ts/datasets-test/*.hpp)
add_executable(boost_test_datasets ${BOOST_TEST_UNITTESTS_DATASET})
target_include_directories(boost_test_datasets PUBLIC ${BOOST_TEST_ROOT_DIR}/include/)
target_link_libraries(boost_test_datasets boost_test_framework)
target_compile_definitions(boost_test_datasets PUBLIC "BOOST_TEST_DYN_LINK=1")
set_target_properties(boost_test_datasets PROPERTIES FOLDER "Unit tests")
add_test(NAME bt-unittest-dataset
         COMMAND boost_test_datasets)


####
# TS writing-test-ts

set(BOOST_UTF_TESTS_IND_FILES
    writing-test-ts
    execution_monitor-ts
    framework-ts
    usage-variants-ts
    utils-ts
    test-organization-ts
    smoke-ts
  )


foreach(_ts IN LISTS BOOST_UTF_TESTS_IND_FILES)

  message("parsing test suite ${_ts}")
  file(GLOB
       _boost_utf_current_tsuite
       ${BOOST_TEST_UNITTESTS_FOLDER}/${_ts}/*.cpp)


  foreach(_h IN LISTS _boost_utf_current_tsuite)
    get_filename_component(_hh ${_h} ABSOLUTE)
    get_filename_component(_name ${_h} NAME_WE)
    file(RELATIVE_PATH _v ${BOOST_TEST_UNITTESTS_FOLDER} ${_hh})
    #get_filename_component(_v "${_v}" DIRECTORY)
    message("adding ${_ts}/${_name}")
    add_executable(${_name} ${_hh})
    target_link_libraries(${_name} PRIVATE boost_test_framework)
    set_target_properties(${_name} PROPERTIES FOLDER "Unit tests/${_ts}")
    add_test(NAME bt-unittest-${_name}
             COMMAND ${_name})
  endforeach()

  unset(_boost_utf_current_tsuite)

endforeach() # test suite

=== libs/beast/example/http/server/small/CMakeLists.txt ===
#
# Copyright (c) 2016-2017 Vinnie Falco (vinnie dot falco at gmail dot com)
#
# Distributed under the Boost Software License, Version 1.0. (See accompanying
# file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
#
# Official repository: https://github.com/boostorg/beast
#

GroupSources(include/boost/beast beast)
GroupSources(example/http/server/small "/")

add_executable (http-server-small
    ${BOOST_BEAST_FILES}
    Jamfile
    http_server_small.cpp
)

set_property(TARGET http-server-small PROPERTY FOLDER "example-http-server")

=== debian/changelog ===
boost1.67 (1.67.0-17ubuntu8) focal; urgency=medium

  * Enable numpy properly on riscv64.

 -- William Grant <wgrant@ubuntu.com>  Wed, 01 Apr 2020 18:51:37 +1100

boost1.67 (1.67.0-17ubuntu7) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:31:37 +0100

boost1.67 (1.67.0-17ubuntu6) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 15:31:23 +0100

boost1.67 (1.67.0-17ubuntu5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Feb 2020 08:44:52 +0100

boost1.67 (1.67.0-17ubuntu4) focal; urgency=medium

  * Use python2 in the autopkg tests.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 17 Jan 2020 14:13:46 +0100

boost1.67 (1.67.0-17ubuntu2) focal; urgency=medium

  [ Dimitri John Ledkov, Matthias Klose, Gianfranco Costamagna ]
  * Don't execute numpy sed on i386, where numpy is not built
  * Drop numpy on i386.
  * libboost-python1.67-dev: Depend on python2-dev instead on python-dev.
  * Explicitly depend on python2 to fix FTBFS

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 08 Jan 2020 17:07:57 +0100

boost1.67 (1.67.0-17) unstable; urgency=medium

  * Expose Python version information in dependencies to Python packages, so
    that removing a supported Python version does not result in silently
    broken reverse dependencies (closes: #948273). Thanks to Andreas Beckmann
    for the patch.

 -- Giovanni Mascellani <gio@debian.org>  Tue, 07 Jan 2020 13:13:25 +0100

boost1.67 (1.67.0-16.1) unstable; urgency=high

  * Non-maintainer upload.
  * Revert the Python 2 removal, this requires a package rename
    that will happen with the transition to 1.71. (Closes: #945840)

 -- Adrian Bunk <bunk@debian.org>  Mon, 06 Jan 2020 14:28:23 +0200

boost1.67 (1.67.0-16) unstable; urgency=medium

  [ Giovanni Mascellani ]
  * Update branch in Vcs-Git and gbp.conf.
  * Patch undefined behaviour leading to crashing libboost-numpy (closes:
    #945987).

  [ Dimitri John Ledkov ]
  * Actually fix python test case using correct CMake syntax.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 11 Dec 2019 14:00:23 +0000

boost1.67 (1.67.0-15) unstable; urgency=medium

  [ Matthias Klose ]
  * Allow stderr in autopkgtests

  [ Dimitri John Ledkov ]
  * Port boost-python autopkgtest to python3
  * Port mpi-python tests
  * Switch autopkgtest deps to python3

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 29 Nov 2019 00:47:48 +0000

boost1.67 (1.67.0-14) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Remove myself from uploaders.
  * Provide and Encode icuabi in libboost-regex shlibdeps. This de-couples
    boost & icu transitions.
  * Drop py2 builds. (Closes: #936227)
  * Drop Debian-only compat py library symlinks. (Closes: #914513)

  [ Giovanni Mascellani ]
  * Add -contract as dependency of -dev-all.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 28 Nov 2019 07:17:15 +0000

boost1.67 (1.67.0-13) unstable; urgency=medium

  * [c573257] Fix FTBFS in boost.compute with GCC-8. (Closes: #921247)
  * [086d453] Trim trailing whitespace.
  * [d21d6e3] Use secure URI in Homepage field.
  * [957aa8b] Bump debhelper from old 9 to 10.

 -- Anton Gladky <gladk@debian.org>  Mon, 04 Feb 2019 15:25:45 +0100

boost1.67 (1.67.0-12) unstable; urgency=medium

  * Add patch to fix FTBFS of package bali-phy on ppc64* (closes: #903665).
  * Ignore file .gitlab-ci.yml when creating the source package.
  * Expose supported Python version as virtual packages, so that reverse
    dependencies can depend on the right package (closes: #911625).
  * Work around broken architecture detection under x32.

 -- Giovanni Mascellani <gio@debian.org>  Wed, 23 Jan 2019 12:14:16 +0100

boost1.67 (1.67.0-11) unstable; urgency=medium

  [ Giovanni Mascellani ]
  * Split debian/rules into arch and indep rules, so that arch-independent
    packages are not uselessly built when arch-dependent packages are
    requested and viceversa (closes: #914053).
    + This should also fix some intermittent FTBFS (closes: #913709).
  * Backport patch to fix build on kFreeBSD (closes: #913710).
  * Quit quickly if compilation fails, in order to save on CPU cycles
    and produce easier-to-read build logs.

  [ Dimitri John Ledkov ]
  * Cherrypick predef upstream patch to correctly detect BOOST_OS_LINUX
    using __linux__ define (closes: #914688).

  [ Giovanni Mascellani ]
  * Replace other appearances of __linux with __linux__.

 -- Giovanni Mascellani <gio@debian.org>  Fri, 30 Nov 2018 18:12:49 +0100

boost1.67 (1.67.0-10) unstable; urgency=medium

  [ Giovanni Mascellani ]
  * Rebuild against icu 63.
    + Add shlibs versioning information and breakages so that reverse
      dependencies are rebuilt appropriately.
  * Fail on errors happening inside bash for loops (closes: #912910).

  [ Dimitri John Ledkov ]
  * Add breaks on nheko in unstable.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 13 Nov 2018 12:47:47 +0000

boost1.67 (1.67.0-9) unstable; urgency=medium

  * Drop rtupdate logic for python2, it was never ported to python3 and
    upstream has moved onto co-installable names anyway. Also python2
    default is not going change ever again.
  * Include patch to unbreak mongo testsuite with boost 1.67 program
    options.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 01 Nov 2018 17:19:30 +0000

boost1.67 (1.67.0-8) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/rules: Remove trailing whitespaces
  * d/watch: Use https protocol

  [ Giovanni Mascellani ]
  * Add a missing #include line.

 -- Giovanni Mascellani <gio@debian.org>  Fri, 26 Oct 2018 17:22:09 +0200

boost1.67 (1.67.0-7) unstable; urgency=medium

  * [99c7ebf] Remove dependency on libstdc++(-4.8|)-dev. (Closes: #908737)

 -- Anton Gladky <gladk@debian.org>  Thu, 13 Sep 2018 20:57:27 +0200

boost1.67 (1.67.0-6) unstable; urgency=medium



=== debian/control ===
Source: boost1.67
Homepage: https://www.boost.org/
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Boost Team <team+boost@tracker.debian.org>
Uploaders:
 Steve M. Robbins <smr@debian.org>,
 Giovanni Mascellani <gio@debian.org>,
 Anton Gladky <gladk@debian.org>
Build-Depends: debhelper (>= 10~), dpkg-dev (>= 1.16.1~), dctrl-tools, chrpath,
 zlib1g-dev, libbz2-dev, libicu-dev (>= 63.1), mpi-default-dev,
 bison, flex, docbook-to-man, help2man, xsltproc, doxygen,
 docbook-xsl, docbook-xml, texlive-latex-base, ghostscript,
 dh-python,
 g++ (>= 4:5-0),
 python2, python-all-dev, python-numpy [amd64 arm64 armhf s390x ppc64el riscv64],
 python3, python3-all-dev (>= 3.1), python3-numpy [amd64 arm64 armhf s390x ppc64el riscv64]
Build-Depends-Indep: graphviz
Build-Conflicts: libopenmpi-dev (= 1.3.2-2)
Vcs-Browser: https://salsa.debian.org/debian/boost
Vcs-Git: https://salsa.debian.org/debian/boost.git -b 1.67.0
Standards-Version: 4.1.1

Package: libboost1.67-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libstdc++-dev
Suggests: libboost1.67-doc,
 libboost-atomic1.67-dev,
 libboost-chrono1.67-dev,
 libboost-container1.67-dev,
 libboost-context1.67-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-contract1.67-dev,
 libboost-coroutine1.67-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-date-time1.67-dev,
 libboost-exception1.67-dev,
 libboost-fiber1.67-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-filesystem1.67-dev,
 libboost-graph1.67-dev,
 libboost-graph-parallel1.67-dev,
 libboost-iostreams1.67-dev,
 libboost-locale1.67-dev,
 libboost-log1.67-dev,
 libboost-math1.67-dev,
 libboost-mpi1.67-dev,
 libboost-mpi-python1.67-dev,
 libboost-numpy1.67-dev [amd64 arm64 armhf s390x ppc64el riscv64],
 libboost-program-options1.67-dev,
 libboost-python1.67-dev,
 libboost-random1.67-dev,
 libboost-regex1.67-dev,
 libboost-serialization1.67-dev,
 libboost-signals1.67-dev,
 libboost-stacktrace1.67-dev,
 libboost-system1.67-dev,
 libboost-test1.67-dev,
 libboost-thread1.67-dev,
 libboost-timer1.67-dev,
 libboost-type-erasure1.67-dev,
 libboost-wave1.67-dev,
 libboost1.67-tools-dev,
 libmpfrc++-dev, libntl-dev
Conflicts: bjam, boost-build, libboost1.42-dev, libboost1.46-dev, libboost1.48-dev, libboost1.49-dev, libboost1.50-dev, libboost1.52-dev, libboost1.53-dev, libboost1.54-dev, libboost1.55-dev, libboost1.57-dev, libboost1.58-dev, libboost1.60-dev, libboost1.61-dev, libboost1.62-dev, libboost1.63-dev, libboost1.65-dev
Description: Boost C++ Libraries development files
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides headers for all Boost libraries.
 .
 Extended precision arithmetic package libmpfrc++-dev or libntl-dev is
 required to use the Boost.Multiprecision wrapping of the respective
 library.

Package: libboost1.67-tools-dev
Architecture: any
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: xsltproc,
 doxygen,
 docbook-xml (>= 4.2),
 docbook-xsl (>= 1.73.2),
 default-jdk (>= 1.4),
 fop (>= 0.94)
Conflicts: bjam, boost-build, libboost1.49-dev, libboost1.53-tools-dev, libboost1.54-tools-dev, libboost1.55-tools-dev, libboost1.57-tools-dev, libboost1.58-tools-dev, libboost1.60-tools-dev, libboost1.61-tools-dev, libboost1.62-tools-dev, libboost1.63-tools-dev, libboost1.65-tools-dev
Replaces: bjam, boost-build, libboost1.49-dev, libboost1.53-dev, libboost1.53-tools-dev
Description: Boost C++ Libraries development tools
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This package provides the auxiliary tools bjam, Boost.Build, bcp,
 inspect, boostbook and quickbook.

Package: libboost1.67-all-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
 libboost1.67-dev,
 libboost1.67-tools-dev,
 libboost-atomic1.67-dev,
 libboost-chrono1.67-dev,
 libboost-container1.67-dev,
 libboost-context1.67-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-coroutine1.67-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-date-time1.67-dev,
 libboost-exception1.67-dev,
 libboost-fiber1.67-dev [i386 hurd-i386 kfreebsd-i386 amd64 kfreebsd-amd64 armel armhf arm64 mips mipsel powerpc ppc64el],
 libboost-filesystem1.67-dev,
 libboost-graph1.67-dev,
 libboost-graph-parallel1.67-dev,
 libboost-iostreams1.67-dev,
 libboost-locale1.67-dev,
 libboost-log1.67-dev,
 libboost-math1.67-dev,
 libboost-mpi1.67-dev,
 libboost-mpi-python1.67-dev,
 libboost-numpy1.67-dev [amd64 arm64 armhf s390x ppc64el riscv64],
 libboost-program-options1.67-dev,
 libboost-python1.67-dev,
 libboost-random1.67-dev,
 libboost-regex1.67-dev,
 libboost-serialization1.67-dev,
 libboost-signals1.67-dev,
 libboost-stacktrace1.67-dev,
 libboost-system1.67-dev,
 libboost-test1.67-dev,
 libboost-thread1.67-dev,
 libboost-timer1.67-dev,
 libboost-type-erasure1.67-dev,
 libboost-wave1.67-dev
Description: Boost C++ Libraries development files (ALL)
 The Boost web site provides free, peer-reviewed, portable C++ source
 libraries. The emphasis is on libraries which work well with the C++
 Standard Library. One goal is to establish "existing practice" and
 provide reference implementations so that the Boost libraries are
 suitable for eventual standardization. Some of the libraries have
 already been proposed for inclusion in the C++ Standards Committee's
 upcoming C++ Standard Library Technical Report.
 .
 This metapackage provides the complete Boost development environment,
 including all separately-packaged libraries.

Package: libboost1.67-doc
Homepage: http://www.boost.org/libs/
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-mathjax
Suggests: libboost1.67-dev (>= ${source:Version})
Conflicts: libboost1.42-doc, libboost1.46-doc, libboost1.48-doc, libboost1.49-doc, libboost1.50-doc, libboost1.52-doc, libboost1.53-doc, libboost1.54-doc, libboost1.55-doc, libboost1.57-doc, libboost1.58-doc, libboost1.60-doc, libboost1.61-doc, libboost1.62-doc, libboost1.63-doc, libboost1.65-doc
Description: Boost.org libraries documentation placeholder
 This package originally provided documentation, but has since fallen
 into disrepair and presently provides no documentation.  Please
 use documentation at www.boost.org.

Package: libboost-atomic1.67.0
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.

Package: libboost-atomic1.67-dev
Homepage: http://www.boost.org/libs/atomic/
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
 libboost1.67-dev (= ${binary:Version}),
 libboost-atomic1.67.0 (= ${binary:Version})
Description: atomic data types, operations, and memory ordering constraints
 This package forms part of the Boost C++ Libraries collection.
 .
 Boost.Atomic is a library that provides atomic data types and
 operations on these data types, as well as memory ordering
 constraints required for coordinating multiple threads through atomic
 variables. It implements the interface as defined by the C++11
 standard, but makes this feature available for platforms lacking
 system/compiler support for this particular C++11 feature.
 .
 Users of this library should already be familiar with concurrency in
 general, as well as elementary concepts such as "mutual exclusion".
 .
 The implementation makes use of processor-specific instructions where
 possible (via inline assembler, platform libraries or compiler
 intrinsics), and falls back to "emulating" atomic operations through
 locking.
Conflicts: libboost-atomic1.53-dev, libboost-atomic1.54-dev, libboost-atomic1.55-dev, libboost-atomic1.57-dev, libboost-atomic1.58-dev, libboost-atomic1.60-dev, libboost-atomic1.61-dev, libboost-atomic1.62-dev, libboost-atomic1.63-dev, libboost-atomic1.65-dev

Package: libboost-chrono1.67.0
Homepage: http://www.boost.org/libs/chrono/
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ representation of time duration, time point, and clocks
 This package forms part of the Boost C++ Libraries collection.
 .
 The Boost.Chrono library provides:
 .
  * A means to represent time durations: managed by the generic duration
    class.Examples of time durations include days, minutes, seconds and
    nanoseconds, which can be represented with a fixed number of clock
    ticks per unit. All of these units of time duration are united with
    a generic interface by the duration facility.
  * A type for representing points in time: time_point. A time_point
    represents an epoch plus or minus a duration. The library leaves
    epochs unspecified. A time_point is associated with a clock.
  * Several clocks, some of which may not be available on a particular
    platform: system_clock, steady_clock and high_resolution_clock. A
    clock is a pairing of a time_point and duration, and a function
    which returns a time_point representing now.
 .
 To make the timing facilities more generally useful, Boost.Chrono
 provides a number of clocks that are thin wrappers around the
 operating system's time APIs, thereby allowing the extraction of wall
 clock time, user CPU time, system CPU time spent by the process:
 .
  * process_real_cpu_clock, captures wall clock CPU time spent by the
    current process.
  * process_user_cpu_clock, captures user-CPU time spent by the current
    process.
  * process_system_cpu_clock, captures system-CPU time spent by the
    current process.
  * a tuple-like class process_cpu_clock, that captures real, user-CPU,
    and system-CPU process times together.
  * a thread_clock thread steady clock giving the time spent by the
    current thread (when supported by a platform).
 .
 Lastly, Boost.Chrono includes typeof registration for duration and
 time_point to permit using emulated auto with C++03 compilers.

=== debian/rules ===
#! /usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Boost libraries for which we want separate packages
# context is conditionally compiled because it is not supported yet on several architectures
# coroutine, and fiber depend on context, so they are also conditionally compiled
boost_libs := atomic chrono container contract date-time exception filesystem	\
              graph graph-parallel iostreams locale log math mpi	\
              mpi-python program-options python random regex	\
              serialization signals stacktrace system test thread timer \
              type-erasure wave

# these are special cases, where /usr/lib name differs from Boost library name
boost_lib_log := log log_setup
boost_lib_math := math_c99 math_c99f math_tr1 math_tr1f
boost_lib_math_long_double := math_c99l math_tr1l
boost_lib_serialization := serialization wserialization
boost_lib_stacktrace := stacktrace_noop stacktrace_addr2line stacktrace_backtrace stacktrace_basic
boost_lib_test := prg_exec_monitor test_exec_monitor unit_test_framework

py2versions = $(shell pyversions -rv)
py3versions = $(shell py3versions -rv)
py2verids = $(subst .,,$(py2versions))
py3verids = $(subst .,,$(py3versions))
pyversions = $(py2versions) $(py3versions)
pyverids = $(py2verids) $(py3verids)

# These are special cases for suffixes.  Generally come from --python-buildid, so begin with a dash.
boost_suffixes_python := $(pyverids)
boost_suffixes_numpy := $(pyverids)
boost_suffixes_mpi-python := $(pyverids)

py2default = $(subst .,,$(shell pyversions -dv))
py3default = $(subst .,,$(shell py3versions -dv))

# Files that are generated by filtering a template
filtered_files =

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

# set the number of build jobs
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  JOBS := -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

version_full := $(shell dpkg-parsechangelog | grep Version | cut -d' ' -f2)
version_upstream := $(shell echo $(version_full) | cut -d'-' -f1)
version_major := $(shell echo $(version_upstream) | cut -d'.' -f1,2)

PKGVERSION = $(version_major)
SOVERSION = $(version_upstream)

icuabi = $(shell apt show libicu-dev 2>/dev/null | sed -n 's/Depends: .*libicu\([0-9]*\) .*/\1/p')
regexicuabi = libboost-regex$(SOVERSION)-icu$(icuabi)

# Function to map Boost component name to set of shared library names
# Input: Boost component name
# Return: shared library names for the given Boost library
boost_lib = $(if $(boost_lib_$(1)), $(boost_lib_$(1)), $(1))

# Function to map Boost component name to set of suffixes for the library
# Input: Boost component name
# Return: suffixes for the given Boost component
boost_suffixes = $(if $(boost_suffixes_$(1)), $(boost_suffixes_$(1)),"")

# Helpers to make basic and decorated library names
# Input: library, suffix
# Return: base library filename for short or full name
mk_base_name = usr/lib/$(DEB_HOST_MULTIARCH)/libboost_$(subst -,_,$(1))$(2)

# Input: component
# Return: package name for shared library or development
mk_pkg_lib = libboost-$(1)$(SOVERSION)
mk_pkg_dev = libboost-$(1)$(PKGVERSION)-dev

# Helpers to generate debhelper input filenames.
# Input: component
# Return: prefix to debhelper filenames
mk_deb_lib = debian/$(call mk_pkg_lib,$(1))
mk_deb_dev = debian/$(call mk_pkg_dev,$(1))

# Helpers that update debhelper .install or .links files
# Input: component, library, suffix
# Output: none
mk_so_files = $(shell echo debian/tmp/$(call mk_base_name,$(2),$(3)).so.$(SOVERSION) >> $(call mk_deb_lib,$(1)).install)
mk_a_files = $(shell echo debian/tmp/$(call mk_base_name,$(2),$(3)).a >> $(call mk_deb_dev,$(1)).install)
mk_ln_files = $(shell echo $(call mk_base_name,$(2),$(3)).so.$(SOVERSION) $(call mk_base_name,$(2),$(3)).so >> $(call mk_deb_dev,$(1)).links)

# Specify the type of files/links to install.
# Special cases first, then general rule
boost_filetypes_exception = a
boost_filetypes_test_exec_monitor = a
boost_filetypes = $(if $(boost_filetypes_$(1)), $(boost_filetypes_$(1)),a so ln)

# Function that updates debhelper files for a given library
# Input: component, library, suffix
# Output: none
mk_files = $(foreach fn,$(call boost_filetypes,$(2)),$(call mk_$(fn)_files,$(1),$(2),$(3)))

# helpers to make and install lintian override files

# Input: package, override
add_override = echo $(1): $(2) >> debian/$(1).lintian-overrides;

# Input: override
add_dev_override = $(call add_override,libboost$(PKGVERSION)-dev,$(1))
add_doc_override = $(call add_override,libboost$(PKGVERSION)-doc,$(1))

# Input: component, lintian-warning
add_lib_override = $(call add_override,$(call mk_pkg_lib,$(1)),$(2))
add_libdev_override = $(call add_override,$(call mk_pkg_dev,$(1)),$(2))

# Input: package-name-base, versioned-package-name
cp_debhelper = set -e ; for s in doc-base examples postinst prerm README.Debian; do \
	if test -f debian/$(1).$$s; then cp -f debian/$(1).$$s debian/$(2).$$s; fi; done

# Function that updates debhelper files for all libraries shipped.
mk_debhelper_files = \
	$(call add_dev_override,extra-license-file) \
	$(call add_doc_override,extra-license-file) \
	$(foreach l, $(boost_libs), \
		echo "making debhelper files for $(l)..."; \
		$(call add_lib_override,$(l),package-name-doesnt-match-sonames) \
		$(foreach ll, $(call boost_lib,$(l)), \
			$(foreach suf, $(call boost_suffixes,$(l)), \
				$(call mk_files,$(l),$(ll),$(suf)) \
			) \
		) \
	)

TOOLSET_CONFIG = 'using gcc : : : <compileflags>"$(CPPFLAGS)" <cflags>"$(CFLAGS)" <cxxflags>"$(CXXFLAGS) -Wno-unused-local-typedefs" <linkflags>"$(LDFLAGS)" ;'
BUILD_CONTEXT = yes
BUILD_LONG_DOUBLE = yes

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

ifeq ($(DEB_BUILD_ARCH), alpha)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), arm)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), armel)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), armhf)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), arm64)
BUILD_LONG_DOUBLE = no
JAM_OPT += pch=off
else ifeq ($(DEB_BUILD_ARCH), hppa)
BUILD_LONG_DOUBLE = no
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), ia64)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), m68k)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), mips)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), mipsel)
BUILD_LONG_DOUBLE = no
else ifeq ($(DEB_BUILD_ARCH), mips64)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), mips64el)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), powerpcspe)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), ppc64)
BUILD_CONTEXT = yes
else ifeq ($(DEB_BUILD_ARCH), ppc64el)
BUILD_CONTEXT = yes
else ifeq ($(DEB_BUILD_ARCH), s390)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), s390x)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), sh4)
BUILD_LONG_DOUBLE = no
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), sparc)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), sparc64)
BUILD_CONTEXT = no
else ifeq ($(DEB_BUILD_ARCH), x32)
BUILD_CONTEXT = no
endif

ifneq ($(DEB_HOST_ARCH), i386)
boost_libs += numpy
endif

ifeq ($(BUILD_CONTEXT), yes)
boost_libs += context coroutine fiber
else
JAM_WITHOUT += --without-context --without-coroutine --without-fiber
endif

ifeq ($(BUILD_LONG_DOUBLE), yes)
boost_lib_math += $(boost_lib_math_long_double)
else
JAM_OPT += --disable-long-double
endif

exampledir = debian/libboost$(PKGVERSION)-doc/usr/share/doc/libboost$(PKGVERSION)-doc/examples
bjam = $(CURDIR)/bjam
bbv2dir = $(CURDIR)/tools/build

# With --ignore-site-config, can probably drop Build-Conflicts on boost-build.
JAM = $(bjam) $(JOBS) -q -d2 $(JAM_OPT) --layout=system --ignore-site-config --user-config=$(CURDIR)/user-config.jam debug-symbols=on
JAM_DOC = $(bjam) $(JOBS) -q -d2 --ignore-site-config --user-config=$(CURDIR)/user-config-doc.jam

%:
	dh $@ --with python2 --with python3

override_dh_auto_configure: user-config.jam make-debhelper
ifeq ($(DEB_BUILD_ARCH), x32)

=== debian/tests/control ===
Tests: atomic
Depends: libboost-atomic1.67-dev, build-essential, cmake

Tests: chrono
Depends: libboost-chrono1.67-dev, libboost-system1.67-dev, build-essential, cmake

Tests: context
Depends: libboost-context1.67-dev, build-essential, cmake

Tests: container
Depends: libboost-container1.67-dev, libboost-system1.67-dev, build-essential, cmake

Tests: coroutine
Depends: libboost-coroutine1.67-dev, libboost-system1.67-dev, build-essential, cmake

Tests: datetime
Depends: libboost-date-time1.67-dev, build-essential, cmake

Tests: exception
Depends: libboost-exception1.67-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: fiber
Depends: libboost-fiber1.67-dev, build-essential, cmake

Tests: filesystem
Depends: libboost-filesystem1.67-dev, build-essential, cmake

Tests: graph
Depends: libboost-graph1.67-dev, build-essential, cmake

Tests: graph-parallel
Depends: libboost-graph-parallel1.67-dev, libboost-mpi1.67-dev, libboost-system1.67-dev, mpi-default-dev, build-essential, libgraph-easy-perl, cmake
Restrictions: allow-stderr

Tests: iostreams
Depends: libboost-iostreams1.67-dev, build-essential, cmake

Tests: locale
Depends: libboost-locale1.67-dev, build-essential, cmake

Tests: log
Depends: libboost-log1.67-dev, build-essential, cmake

Tests: math
Depends: libboost-math1.67-dev, build-essential, cmake

Tests: mpi
Depends: libboost-mpi1.67-dev, mpi-default-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: mpi-python
Depends: libboost-mpi-python1.67-dev, mpi-default-dev, python2
Restrictions: allow-stderr

Tests: program-options
Depends: libboost-program-options1.67-dev, build-essential, cmake

Tests: python
Depends: libboost-python1.67-dev, python2, cmake, build-essential, clang

Tests: random
Depends: libboost-random1.67-dev, build-essential, cmake

Tests: regex
Depends: libboost-regex1.67-dev, build-essential, cmake, html2text

Tests: serialization
Depends: libboost-serialization1.67-dev, libboost-random1.67-dev, build-essential, cmake

Tests: signals
Depends: libboost-signals1.67-dev, build-essential, cmake

Tests: stacktrace
Depends: libboost-stacktrace1.67-dev, libboost-system1.67-dev, build-essential, cmake

Tests: system
Depends: libboost-system1.67-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: test
Depends: libboost-test1.67-dev, build-essential, cmake
Restrictions: allow-stderr

Tests: thread
Depends: libboost-thread1.67-dev, build-essential, cmake

Tests: timer
Depends: libboost-timer1.67-dev, build-essential, cmake

Tests: type-erasure
Depends: libboost-type-erasure1.67-dev, build-essential, cmake

Tests: wave
Depends: libboost-wave1.67-dev, libboost-thread1.67-dev, build-essential, cmake

=== debian/watch ===
version=3
opts="uversionmangle=s/_/./g,dversionmangle=s/\+dfsg$//" https://sf.net/boost/boost_([\d_]*)\.tar.bz2

# Note: the above does not work, even with the fixed reflector mentioned
# in this thread: https://lists.debian.org/debian-devel/2016/10/msg00280.html
# Workaround: run: mk-origtargz --repack ../boost_1_63_0.tar.bz2
